import java.util.regex.Pattern;
import java.util.regex.Matcher;
import java.io.File;
import java.io.FileWriter;
import java.io.BufferedWriter;
import java.io.IOException;
import java.util.StringTokenizer;

//全部selectinput()に書き換える

// Digital Material Cube 008
// FabLab Japan
// Hiroya Tanaka

boolean testttt = false;
String format;

// Import for ESO
import processing.dxf.*;
import processing.opengl.*;
import javax.media.opengl.*;
import controlP5.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*; 
import java.awt.event.*; 

float elastic01 = 1000;
float elastic02 = 0.01;

/* world */
int worldLength = 20000;
int gridLength = 500;

/* font */
PFont font14;
PFont font7;


/* export */
boolean exportFlg = false;

/* auto evolve one night */
boolean evolution = false;

/* resolution of the cube */
int blocks = 10;  // resolution of voxels, each of X, Y, Z
int num = blocks*blocks*blocks;
Cell[] p = new Cell[num];
Cell[][][] p2 = new Cell[blocks][blocks][blocks];
Cell[] currentCell = new Cell[1];

int selx = gridLength/2;
int sely = gridLength/2;
int selz = gridLength/2;

int currentX, currentY, currentZ;

/* Strings */
String sparam;
String filename;
String outputdir = "C:\\PROGRA~2\\CalculiX\\common\\site\\";  // the directory where the output will be saved. 
String workdir = "C:\\PROGRA~2\\CalculiX\\common\\site\\"; // the directory where "cmdStartup" is installed
String batchfiledir = workdir + "cmdStartup.bat"; // cmd Startup is there 

String[] st = new String[1000000];
String[] sadat = new String[1000000];
String[] mises = new String[1000000];
double[] mp = new double[num];
int[] GROWTHnum = new int[blocks*blocks*blocks];

/* Publics defined by Sliders */
public int TRANSPARENCY = 100;
public int THRESHOLD_MIN = 100;
public int THRESHOLD_MAX = 110;
public int BURDEN = 230;

public int numberOfSteps = 0;
/* Rotations */
float xmag, ymag = 0;
float newXmag, newYmag = 0; 


// Import Mesh Library 
import toxi.geom.*;
import toxi.geom.mesh.*;
import toxi.geom.mesh.subdiv.*;
import toxi.processing.*;
import toxi.util.*;
import toxi.volume.*;
ToxiclibsSupport gfx;
WETriangleMesh mesh;

boolean mesh_display = true;
boolean voxel_display = true;
boolean wire_display = true;
boolean eso_display = false;

// Import
import processing.opengl.*;
import javax.media.opengl.*;  
import controlP5.*;
import javax.swing.*;
//import SpringGUI.*;
//SpringGUI gui; 

// File IO
String getFile; 
String setFile;
String ssetFile;
String [] txtarray = null;
String txt = null;

// Field 
int FIELD_SIZE =  50;
int FIELD_STEP =  10;

// Camera 
float expo = 1;
float rotx, roty;
float rate = 0.01;

// Resolution of Box
int resolution = 1;

// ControlP5
ControlP5 controlP5;
Textfield tfUserName;       // テキストフィールド
String txts = "";

// Text
PFont  font;  
long   time;  

// Unlekker
import unlekker.data.*;
import unlekker.geom.*;
STL stl;
FaceList poly;
int faces; // メッシュの数

// Array 
int[][] xyarrays = new int[48][48];
int[][] yzarrays = new int[48][48];
int[][] zxarrays = new int[48][48];
int[][][] xyzarrays = new int[48][48][48];


void setup() {
  setFile = ""; 
  getFile = "";

  // Array初期化
  for (int k = 0; k<48; k = k + 1) {
    for (int j = 0; j<48; j = j + 1) {
      for (int i = 0; i<48; i = i + 1) {
        xyzarrays[k][j][i] = 0;
      }
    }
  }

  //Cell初期化
  int num=0;
  for ( int k=0; k<blocks; k++) { 
    for (int j=0; j<blocks; j++) { 
      for (int i=0; i<blocks; i++) {      
        p[num]= new Cell(i*gridLength - gridLength*blocks/2 + gridLength/2, j*gridLength- gridLength*blocks/2 + gridLength/2, k*gridLength - gridLength*blocks/2 + gridLength/2, gridLength, -1);
        p2[i][j][k] = p[num];
        if (p[num].x == selx && p[num].y == sely && p[num].z == selz) { 
          currentCell[0] = p[num]; 
          currentX = i; 
          currentY = j; 
          currentZ = k;
        }
        //        if(i == 0) p[num].setstate(6);
        p[num].setstate(9);
        num=num+1;
      }
    }
  }


  size(640, 480, OPENGL);    
  gfx=new ToxiclibsSupport(this);
  controlP5 = new ControlP5(this);  
  controlP5.addButton("loadfile", 1, 10, 45, 80, 19);
  controlP5.addButton("savefile", 1, 100, 45, 80, 19);
  controlP5.addButton("voxelize", 1, 190, 45, 80, 19);
  controlP5.addSlider("resolution", 1, 48, 10, 70, 200, 20);

  // controlP5.addSlider("slice",1,48,10,100,200,20);

  controlP5.addButton("AUTO", 1, 10, 95, 80, 19);
  controlP5.addButton("saveVoxel", 1, 10, 115, 80, 19);
  controlP5.addButton("loadVoxel", 1, 10, 135, 80, 19);

  controlP5.addToggle("mesh_display", true, 300, 45, 20, 10).setMode(ControlP5.SWITCH);
  controlP5.addToggle("voxel_display", true, 400, 45, 20, 10).setMode(ControlP5.SWITCH);
  controlP5.addToggle("wire_display", true, 500, 45, 20, 10).setMode(ControlP5.SWITCH);
  controlP5.addToggle("ESO", false, 300, 70, 20, 10).setMode(ControlP5.SWITCH);
}


void draw() {

  background(0);
  PGraphicsOpenGL pgl = (PGraphicsOpenGL)g;  

  // Lighting
  ambientLight(150, 150, 150);
  directionalLight(255, 255, 255, -1, 0, 0);
  pointLight(160, 160, 160, 200, 200, 200);
  spotLight(100, 100, 100, 200, 200, 200, 0, 0, -1, PI, 2);

  // Camera
  if (keyPressed && getFile == "" && setFile == "") {
    rotx = rotx + (mouseY - pmouseY) * rate;
    roty = roty + (mouseX - pmouseX) * rate;
  } 


  // FileIO
  if (getFile != "") {
    //ファイルを取り込む
    fileLoader();
  } 

  //Text
  font = createFont("Meiryo", 12);
  textFont(font);
  fill(255, 255, 255);
  text("08  STL to VOXEL in Mesh * triangle ", 10, 25); 

  // Zoom In and Out
  if (keyPressed && keyCode==UP) { 
    expo = expo + 0.01;
  }
  if (keyPressed && keyCode==DOWN) { 
    expo = expo - 0.01;
  }

  // 中心を合わせる
  pushMatrix(); 
  translate(320, 240, 200);
  rotateX(rotx); 
  rotateY(roty); 
  scale(expo);  
  
  //Output Voxel(Binary) data
  if (setFile != "" && format == "txt") {
    writeVoxel();
    setFile = "";
    format = txt;
  }
  
  // STL書き出し
  if (setFile != "" && format == "stl") {
    beginRaw("unlekker.data.STL", setFile+".stl");
    println("start :"+setFile);
  }

  pushStyle();
  // フレームの描画
  if (wire_display == true) {

    stroke(255, 255, 255);  
    FIELD_STEP = FIELD_SIZE*2/resolution;

    for (int k = 1; k<=resolution; k = k + 1) {
      for (int j = 1; j<=resolution; j = j + 1) {
        for (int i = 1; i<=resolution; i = i + 1) {

          // x
          float x = -FIELD_SIZE + FIELD_STEP*(i - 1);
          float xx = -FIELD_SIZE + FIELD_STEP*(i);
          float realx = (x + xx)/2; 
          // y
          float y = -FIELD_SIZE + FIELD_STEP*(j - 1);
          float yy = -FIELD_SIZE + FIELD_STEP*(j);
          float realy = (y + yy)/2; 
          // z
          float z = -FIELD_SIZE + FIELD_STEP*(k - 1);
          float zz = -FIELD_SIZE + FIELD_STEP*(k);
          float realz = (z + zz)/2; 

          pushMatrix(); 
          translate(realx, realy, realz);
          noFill();

          box(FIELD_STEP, FIELD_STEP, FIELD_STEP );

          popMatrix();
        }
      }
    }
  }
  popStyle();




  // メッシュの描画


  if (poly!=null && mesh_display == true) {
    fill(255, 255, 255);
    noStroke();
    poly.draw(this);
  }



  // ボクセルの描画  

  if ( voxel_display == true ) {
    noStroke();
    noFill();
    int len = txts.length(); 
    int l = 0;

    FIELD_STEP = FIELD_SIZE*2/resolution;

    for (int k = 1; k<=resolution; k = k + 1) {
      for (int j = 1; j<=resolution; j = j + 1) {
        for (int i = 1; i<=resolution; i = i + 1) {

          //x
          float x = -FIELD_SIZE + FIELD_STEP*(i - 1);
          float xx = -FIELD_SIZE + FIELD_STEP*(i);
          float realx = (x + xx)/2; 
          //y
          float y = -FIELD_SIZE + FIELD_STEP*(j - 1);
          float yy = -FIELD_SIZE + FIELD_STEP*(j);
          float realy = (y + yy)/2; 
          //z
          float z = -FIELD_SIZE + FIELD_STEP*(k - 1);
          float zz = -FIELD_SIZE + FIELD_STEP*(k);
          float realz = (z + zz)/2; 

          pushMatrix();
          translate(realx, realy, realz); 
          if (xyzarrays[i-1][j-1][k-1] == 1) { 
            if (eso_display == true) p[(i-1 + resolution*(j-1) + (resolution*resolution)*(k-1))].display(TRANSPARENCY, THRESHOLD_MIN, THRESHOLD_MAX);
            else fill(200, 00, 00);
            box(FIELD_STEP, FIELD_STEP, FIELD_STEP);
          }

          popMatrix();
        }
      }
    }
  }
  popMatrix();

  // STL書き出し終了
  if (setFile != "" && format == "stl") {
    endRaw();   
    setFile = "";
    format = "";  
    println("end");
  }

  // α合成を有効にする
  GL gl = pgl.beginGL();
  gl.glEnable(GL.GL_BLEND);
  gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA);  
  gl.glDisable(GL.GL_DEPTH_TEST);
  pgl.endGL();


  // GUI コンポーネント描画のための設定
  camera();
  gl = pgl.beginGL();
  gl.glDisable(GL.GL_DEPTH_TEST);  // 深度テストを無効化
  gl.glEnable(GL.GL_BLEND);
  gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA);  
  pgl.endGL();

  //ESO
  if (evolution == true) {
    int de = DOEVOLUTION();
    //     exportFlg = true;
    if (de == 0) { 
      evolution = false;
    }
  }

  /* begin export */
  if (exportFlg) {
    println("Begin export");
    beginRaw(DXF, "testton01.dxf");//outputdir+year()+"_"+month()+"_"+day()+"_"+minute()+"_"+second()+".dxf");
    //    beginRaw(PDF, outputdir+"testton.pdf");// outputdir+year()+"_"+month()+"_"+day()+"_"+minute()+"_"+second()+".pdf");
  }

  for (int i = 0; i < p.length; i++) {
    //    p[i].display(TRANSPARENCY,THRESHOLD_MIN,THRESHOLD_MAX);
  }

  /* end export */
  if (exportFlg) {
    endRaw();
    //    save(outputdir+year()+"_"+month()+"_"+day()+"_"+minute()+"_"+second()+".tif");  
    exportFlg=false;
    println("End export");
  }
}


// テキストが入力された際にコールバックされるメソッド
public synchronized void textfield(String txt) {
  txts = txt;
}


public void loadfile(int theValue) {
  getFile = getFileName();
}


public void savefile(int theValue) {
  setFile = setFileName();
  format = "stl";
}

public void voxelize(int theValue) {

  // メッシュの数：int faces　　
  // AABB * AABBの衝突判定をつかってみる


  FIELD_STEP = FIELD_SIZE*2/resolution;

  for (int k = 1; k<=resolution; k = k + 1) {
    for (int j = 1; j<=resolution; j = j + 1) {
      for (int i = 1; i<=resolution; i = i + 1) {

        // x
        float x = -FIELD_SIZE + FIELD_STEP*(i - 1);
        float xx = -FIELD_SIZE + FIELD_STEP*(i);
        float realx = (x+xx)/2; 
        // y
        float y = -FIELD_SIZE + FIELD_STEP*(j - 1);
        float yy = -FIELD_SIZE + FIELD_STEP*(j);
        float realy = (y+yy)/2;

        //z
        float z = -FIELD_SIZE + FIELD_STEP*(k - 1);
        float zz = -FIELD_SIZE + FIELD_STEP*(k);
        float realz = (z+zz)/2;



        for (int q = 0; q< poly.f.length; q= q + 1) {

          PVector pv1 = new PVector (poly.f[q].v[3], poly.f[q].v[4], poly.f[q].v[5] );
          PVector pv2 = new PVector (poly.f[q].v[6], poly.f[q].v[7], poly.f[q].v[8]);
          PVector pv3 = new PVector (poly.f[q].v[9], poly.f[q].v[10], poly.f[q].v[11]);
          PVector bmin = new PVector (x, y, z);
          PVector bmax = new PVector (xx, yy, zz);       

          boolean preresult = preAABB(x, y, z, xx, yy, zz, min(poly.f[q].v[3], poly.f[q].v[6], poly.f[q].v[9]), min(poly.f[q].v[4], poly.f[q].v[7], poly.f[q].v[10]), min(poly.f[q].v[5], poly.f[q].v[8], poly.f[q].v[11]), 
          max(poly.f[q].v[3], poly.f[q].v[6], poly.f[q].v[9]), max(poly.f[q].v[4], poly.f[q].v[7], poly.f[q].v[10]), max(poly.f[q].v[5], poly.f[q].v[8], poly.f[q].v[11]));
          boolean result;
          if (preresult == true) {  
            result= SPETestTriangleAABB(pv1, pv2, pv3, bmin, bmax);
          } 
          else { 
            result =false;
          }
          boolean result2 = AABB(x, y, z, xx, yy, zz, min(poly.f[q].v[3], poly.f[q].v[6], poly.f[q].v[9]), min(poly.f[q].v[4], poly.f[q].v[7], poly.f[q].v[10]), min(poly.f[q].v[5], poly.f[q].v[8], poly.f[q].v[11]), 
          max(poly.f[q].v[3], poly.f[q].v[6], poly.f[q].v[9]), max(poly.f[q].v[4], poly.f[q].v[7], poly.f[q].v[10]), max(poly.f[q].v[5], poly.f[q].v[8], poly.f[q].v[11]));

          if (result == true || result2 == true ) {      
            xyzarrays[i-1][j-1][k-1] = 1;  
            break;
          } 
          else { 
            xyzarrays[i-1][j-1][k-1] = 0;
          }
        }
      }
    }
  }
}

// AABBどうちの接触を調べる
public boolean preAABB(float aminx, float aminy, float aminz, float amaxx, float amaxy, float amaxz, float bminx, float bminy, float bminz, float bmaxx, float bmaxy, float bmaxz) {
  // 衝突	
  if (              aminx < bmaxx && amaxx > bminx
    && aminy < bmaxy && amaxy > bminy
    && aminz < bmaxz && amaxz > bminz)
  {
    //println("1a");
    return(true);
  }
  if (              bminx < amaxx && bmaxx > aminx
    && bminy < amaxy && bmaxy > aminy
    && bminz < amaxz && bmaxz > aminz)
  {
    // println("1b");
    return(true);
  }
  return(false);
}


public boolean AABB(float aminx, float aminy, float aminz, float amaxx, float amaxy, float amaxz, float bminx, float bminy, float bminz, float bmaxx, float bmaxy, float bmaxz) {


  // 包含
  if (              aminx < bminx && bmaxx < amaxx
    && aminy < bminy && bmaxy < amaxy
    && aminz < bminz && bmaxz < amaxz)
  {
    //println("2");
    return(true);
  }

  return(false);
}

// 座標 p1,p2 を通る直線と座標 p3,p4 を結ぶ線分が交差しているかを調べる
public boolean intersection(float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4) {

  if (((x1 - x2) * (y3 - y1) + (y1 - y2) * (x1 - x3)) * ((x1 - x2) * (y4 - y1) + (y1 - y2) * (x1 - x4)) <= 0 &&
    ((x3 - x4) * (y1 - y3) + (y3 - y4) * (x3 - x1)) * ((x3 - x4) * (y2 - y3) + (y3 - y4) * (x3 - x2)) <= 0 ) {

    return(true); //交差する
  } 
  return(false); //交差しない
}



/*------------
 ESO
 ------------*/
void ESO() {
  eso_display = !eso_display;
  int num = 0;
  if (!testttt) {
    for (int k = 1; k<=resolution; k = k + 1) {
      for (int j = 1; j<=resolution; j = j + 1) {
        for (int i = 1; i<=resolution; i = i + 1) {
          if (xyzarrays[k-1][j-1][i-1]== 1) p[num].setstate(1);
          if (k == 0) p[num].setstate(9);
          if (k==resolution) p[num].setstate(6);
          num = num + 1;
        }
      }
    }
    testttt = true;
  }
  for (int i=0; i<num; i++) {
    println(p[i].state);
  }
  println(eso_display);
}


//void loadVoxel(){
//
//
//
//  try {
//    BufferedReader br = new BufferedReader(new FileReader("/Users/t10501am/test.txt")); 
//    String line;
//    //ファイルの件数分ループして配列に格納します。 
//    while ((line = br.readLine())!= null) {
////      println(line);
//String[] matches = match(line, "\\D+");
//String[] matches2 = match(line, "[0-9]+");
//println(matches);
////  tmp = parseInt(matches[1]);
////      println(matches);
//    }
//    br.close();
//  } 
//  catch (Exception ex) {
//    ex.printStackTrace();
//  }
//}

void loadVoxel() {

  String regex = "(\\D+)([0-9]+)";
  String target;
  Matcher matcher;
  Pattern pattern;

  //  int resolution = 0;
  int[][][] tmpxyzarrays = new int[48][48][48];
  int currentX = 0;
  int currentY = 0;

  String loadPath = getFile;//selectInput();//openn window and select file
  if (loadPath == null) {
    // If a file was not selected
    println("No input file was selected...");
  }
  else {
    try {
      BufferedReader br = new BufferedReader(new FileReader(loadPath)); 
      //ファイルの件数分ループして配列に格納します。 
      while ( (target = br.readLine ())!= null) {      
        pattern = Pattern.compile(",");
        String[] strs = pattern.split(target);

        if (strs[0].equals("resolution")) {
          resolution = Integer.parseInt(strs[1]);
        }
        else {
          for (int i=0;i<resolution;i++) {
            tmpxyzarrays[currentX][currentY][i] = Integer.parseInt(strs[i]);
          }
          currentY = currentY + 1;
          if (currentY == resolution) {
            currentY = 0;
            currentX = currentX + 1;
          }
        }
      }
      br.close();
    } 
    catch (Exception ex) {
      ex.printStackTrace();
    }
    xyzarrays = tmpxyzarrays;
    println("Loading voxel data was completed.");
    println("Resolution : " + resolution);
  }
}

void saveVoxel() {
  setFile = setFileName();
  format = "txt";
}

void writeVoxel() {
  String savePath = setFile;

  if (savePath == null) {
    // If a file was not selected
    println("No output file was selected...");
  }
  else {
    try {
      File file = new File(savePath + format);
      PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter(file)));
      pw.println("resolution," + resolution);

      for (int i=0; i<resolution; i++) {
        for (int j=0; j<resolution; j++) {
          for (int k=0; k<resolution; k++) {
            pw.print(xyzarrays[i][j][k]);
            if (k<resolution-1) pw.print(",");
          }
          pw.print("\n");
        }
      }
      pw.close();
    }
    catch(IOException e) {
      System.out.println(e);
    }
  }
  setFile = "";
  format = "";  
  println("end");
}

